<!DOCTYPE html>
<html>

<head>
  <meta charset='utf-8'>
  <title>Task 25.40 order detail</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body onload="onPageLoading()">
  <div class = "container">
    <h1>Order Detail</h1>
    <div class = "form-group">
      <label>Order Code (mã đơn hàng) </label>
      <input class = "form-control" id="order-code" placeholder="...">
      <label>Kích cỡ</label>
      <select class = "form-control" id="select-combo">
        <option>Chọn cỡ Combo (combo size)</option>
        <option>S</option>
        <option>M</option>
        <option>L</option>
      </select>          
      <label>Đường kính</label>
      <input class = "form-control" id="duong-kinh" placeholder="...">
      <label>Sườn</label>
      <input class = "form-control" id="suon" placeholder="...">
      <label>Salad</label>
      <input class = "form-control" id="salad" placeholder="...">
      <label>Loại pizza</label>
      <select class = "form-control" id="select-pizza">
        <option>Chọn loại pizza</option>
        <option value = "seafood">Hải sản</option>
        <option value = "hawaii">Ha wai</option>
        <option value = "bacon">Thịt hun khói</option>
      </select>
      <label>Voucher ID</label>
      <input class = "form-control" id="id-voucher" placeholder="...">
      <label>Thành tiền</label>
      <input class = "form-control" id="thanh-tien" placeholder="...">
      <label>Giảm giá</label>
      <input class = "form-control" id="giam-gia" placeholder="...">
      <label>Loại nước uống</label>
      <select class = "form-control" id="select-drink">
        <option>...</option>
      </select>
      <label>Số lượng nước</label>
      <input class = "form-control" id="so-luong-nuoc" placeholder="...">
      <label>Họ và tên</label>
      <input class = "form-control" id="ho-va-ten" placeholder="...">
      <label>Email</label>
      <input class = "form-control" id="email" placeholder="...">
      <label>Số điện thoại</label>
      <input class = "form-control" id="dien-thoai" placeholder="...">
      <label>Địa chỉ</label>
      <input class = "form-control" id="dia-chi" placeholder="...">
      <label>Lời nhắn</label>
      <input class = "form-control" id="loi-nhan" placeholder="...">
      <label>Trạng thái</label>
      <input class = "form-control" id="trang-thai" placeholder="...">
      <label>Ngày tạo</label>
      <input class = "form-control" id="ngay-tao" placeholder="...">
      <label>Ngày cập nhật</label>
      <input class = "form-control"  id="ngay-cap-nhat" placeholder="...">
    </div>
  </div>
</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gREQUEST_STATUS_OK = 200;
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
  const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
  const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
  var gOrderCode;
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
 //hàm xử lý sự kiện tải trang
 function onPageLoading(){
    var vUrlString = window.location.href;
    console.log(vUrlString);
    //tạo đối tượng url để truy vấn tham số
    var vUrl = new URL(vUrlString);
    //truy vấn
    gOrderCode = vUrl.searchParams.get("orderCode");
    //b2: validate
    const vFORM_LIST_VIEW = "createOrderForm.html";
    if (gOrderCode == null || gOrderCode == ""){
      alert ("Không có order code");
      window.location.href = vFORM_LIST_VIEW;
    }    
    console.log("Order code (mã đơn hàng): " + gOrderCode);
    var vOrderCodeInp = document.getElementById("order-code");
    vOrderCodeInp.value = gOrderCode;
    //load data vào select drink element
    loadDataDrinkList();
    //b3: gọi Api
    var vXmlHttpOrder = new XMLHttpRequest();
    callApiOrderData(vXmlHttpOrder, gOrderCode);
    //hàm response text trả về
    vXmlHttpOrder.onreadystatechange = function () {
      if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
        showDataToForm(vXmlHttpOrder);
      }
    }
 }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function callApiOrderData(paramXmlHttpOrder, paramOrderCode) {
        "use strict";
        //base url
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";        
        paramXmlHttpOrder.open("GET", vBASE_URL + "/" + paramOrderCode, true);
        paramXmlHttpOrder.send();        
    }
//call api để load data drink list (danh sách loại nước uống) về
function loadDataDrinkList() {
    "use strict";
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/drinks";
    var vXmlHttp = new XMLHttpRequest();
    vXmlHttp.open("GET",vBASE_URL, true);
    vXmlHttp.send();
    vXmlHttp.onreadystatechange = function () {
      if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
        console.log(vXmlHttp.responseText); //ghi response text ra console.log
        handleLoadDataToSelectDrink(vXmlHttp);
      }
    };          
  }
//gán giá trị drink list vào select element
function handleLoadDataToSelectDrink(paramXmlHttp){
  var vArrayDrinkList = JSON.parse(paramXmlHttp.responseText);
  console.log("Array drinklist = " + vArrayDrinkList.length);
  //load data to drink select
  var vSelectDrink = document.getElementById("select-drink");
  for (var bI = 0; bI < vArrayDrinkList.length; bI++){
    var vDrinkOption = document.createElement("option");
    vDrinkOption.value = vArrayDrinkList[bI].maNuocUong;
    vDrinkOption.text =  vArrayDrinkList[bI].tenNuocUong;
    vSelectDrink.appendChild(vDrinkOption);
  }
}
//hàm hiển thị dữ liệu trên form
function showDataToForm(paramXmlHttp){
    "use strict";
    console.log(paramXmlHttp.responseText); //yc1
    //yc2:
    var vOrderDataObj = JSON.parse(paramXmlHttp.responseText);//parsing thành object
    //truy xuất các phần tử trên form
    var vOrderCode = document.getElementById("order-code");
    var vCombo = document.getElementById("select-combo");
    var vDuongKinh = document.getElementById("duong-kinh");
    var vDrink = document.getElementById("select-drink");
    var vSoLuongDoUong = document.getElementById("so-luong-nuoc");
    var vPizzaType = document.getElementById("select-pizza");
    var vSalad = document.getElementById("salad");
    var vThanhTien = document.getElementById("thanh-tien");
    var vVoucherId = document.getElementById("id-voucher");
    var vSuonNuong = document.getElementById("suon");
    var vGiamGia = document.getElementById("giam-gia");
    var vName = document.getElementById("ho-va-ten");
    var vEmail = document.getElementById("email");
    var vAddress = document.getElementById("dia-chi");
    var vPhone = document.getElementById("dien-thoai");
    var vMessage = document.getElementById("loi-nhan");
    var vStatus = document.getElementById("trang-thai");
    var vNgayTao = document.getElementById("ngay-tao");
    var vNgayCapNhat = document.getElementById("ngay-cap-nhat");
    //gán giá trị của các phần tử từ order object
    vOrderCode.value = vOrderDataObj.orderCode;
    vCombo.value = vOrderDataObj.kichCo;
    vDuongKinh.value = vOrderDataObj.duongKinh;
    vDrink.value = vOrderDataObj.idLoaiNuocUong;
    vSoLuongDoUong.value = vOrderDataObj.soLuongNuoc;
    vPizzaType.value = vOrderDataObj.loaiPizza;
    vSalad.value = vOrderDataObj.salad;
    vThanhTien.value = vOrderDataObj.thanhTien;
    vVoucherId.value = vOrderDataObj.idVourcher;
    vSuonNuong.value = vOrderDataObj.suon;
    vGiamGia.value = vOrderDataObj.giamGia;
    vName.value = vOrderDataObj.hoTen;
    vEmail.value = vOrderDataObj.email;
    vAddress.value = vOrderDataObj.diaChi;
    vPhone.value = vOrderDataObj.soDienThoai;
    vMessage.value = vOrderDataObj.loiNhan;
    vStatus.value = vOrderDataObj.trangThai;
    vNgayTao.value = vOrderDataObj.ngayTao;
    vNgayCapNhat.value = vOrderDataObj.ngayCapNhat;
}
</script>

</html>